#!/usr/bin/wish -f
frame .one -bg grey85 -width 800 -height 60
frame .two -bg grey85 -width 800 -height 60
frame .twoB -bg grey85 -width 800 -height 60
frame .twoC -bg grey85 -width 800 -height 60
frame .three -bg grey85 -width 800 -height 50
frame .four -bg grey85 -width 500 -height 40
frame .five -bg grey85 -width 500 -height 40
frame .six -bg grey85 -width 500 -height 40
frame .seven -bg grey85 -width 500 -height 40
frame .eight -bg grey85 -width 500 -height 40
frame .eightB -bg grey85 -width 500 -height 40
frame .eightC -bg grey85 -width 500 -height 40
frame .nine -bg grey85 -width 500 -height 40
frame .nineB -bg grey85 -width 500 -height 40
frame .nineC -bg grey85 -width 500 -height 40
frame .ten -bg grey85 -width 500 -height 40
frame .eleven -bg grey85 -width 500 -height 40
frame .twelveA -bg grey85 -width 500 -height 40
frame .twelveB -bg grey85 -width 500 -height 40
frame .twelveC -bg grey85 -width 500 -height 40
frame .twelveD -bg grey85 -width 500 -height 40
frame .twelveE -bg grey85 -width 500 -height 40
frame .test -bg grey85 -width 500 -height 40
frame .vary -bg grey85 -width 500 -height 40
frame .vary1 -bg grey85 -width 500 -height 40
frame .vary2 -bg grey85 -width 500 -height 40
frame .vary3 -bg grey85 -width 500 -height 40
frame .best -bg grey85 -width 500 -height 40
frame .best1 -bg grey85 -width 500 -height 40
frame .best2 -bg grey85 -width 500 -height 40
frame .control -bg grey85 -width 500 -height 20
label .one.caption -text " Spectral Analysis" -font {times 28 {italic}}
pack .one.caption -side left
label .one.caption2 -text "v1.01"
pack .one.caption2 -side left
button .two.spectrum -text "Input Observed Spectrum" -command Getspectrum
pack .two.spectrum -side left
label .twoB.spectrum -justify left -textvariable spectrum -relief sunken -width 40
pack .twoB.spectrum -side left
label .twoC.label -text " Model Computation:" -font {times 14}
pack .twoC.label -side left
label .three.select -text Select: -width 10
pack .three.select -side left
button .three.model -text model -command Getmodel
pack .three.model -side left
button .three.atom -text atom -command Getatom
pack .three.atom -side left
button .three.isotope -text isotope -command Getisotope
pack .three.isotope -side left
button .three.lines -text "line list" -command Getline
pack .three.lines -side left
button .three.output -text output -command Getoutput
pack .three.output -side left
label .four.modellabel -text "Model   " -width 12 -justify left
label .four.model -justify left -textvariable model -relief sunken -width 40
pack .four.modellabel .four.model -side left
label .five.atomlabel -text "Atom    " -width 12 -justify left
label .five.atom -justify left -textvariable atom -relief sunken -width 40
pack .five.atomlabel .five.atom -side left
label .six.isotopelabel -text "Isotope " -width 12 -justify left
label .six.isotope -justify left -textvariable isotope -relief sunken -width 40
label .six.isotopestar -text "*" -justify left
pack .six.isotopelabel .six.isotope .six.isotopestar -side left
label .seven.linelabel -text "Line List " -width 12 -justify left
label .seven.lines -justify left -textvariable lines -relief sunken -width 40
pack .seven.linelabel .seven.lines -side left
label .eight.outputlabel -text "Output " -width 12 -justify left
label .eight.output -justify left -textvariable output -relief sunken -width 40
pack .eight.outputlabel .eight.output -side left
label .eightB.star -text "*Isotope selection not used unless isotope switch checked below" -font {fixed 6}
pack .eightB.star -side left
label .nine.switchlabel -text "Switches: " -relief groove
pack .nine.switchlabel -side left
checkbutton .nineB.0 -text "Isotope" -variable flagi
checkbutton .nineB.1 -text "Atlas9" -variable flag9
pack .nineB.0 .nineB.1 -side left 
label .nineC.label -text "Computation Parameters:" -relief groove
pack .nineC.label -side left
label .ten.startlabel -text "Start Wavelength " -justify left
entry .ten.startentry -textvariable start -width 9 -relief sunken -background white
label .ten.sA -text "A  " -justify left
label .ten.endlabel -text "End " -justify left
entry .ten.endentry -textvariable end -width 9 -relief sunken -background white
label .ten.eA -text "A  " -justify left
label .ten.spacelabel -text "Spacing " -justify left
entry .ten.spaceentry -textvariable space -width 6 -relief sunken -background white
label .ten.spA -text "A  " -justify left
pack .ten.startlabel .ten.startentry .ten.sA .ten.endlabel .ten.endentry .ten.eA .ten.spacelabel .ten.spaceentry .ten.spA -side left
label .eleven.mtvlabel -text "Microturbulent Velocity " -justify left
entry .eleven.mtventry -textvariable vt -width 4 -relief sunken -background white
label .eleven.kms -text "km/s " -justify left
pack .eleven.mtvlabel .eleven.mtventry .eleven.kms -side left
label .twelveA.mtv -text "Macroturbulent Velocity: "
checkbutton .twelveA.0 -variable flagmt
entry .twelveA.entry -textvariable mt -width 6 -relief sunken -background white
label .twelveA.kms -text "km/s"
pack .twelveA.mtv .twelveA.0 .twelveA.entry .twelveA.kms -side left
label .twelveB.rotate -text "Rotation: "
checkbutton .twelveB.0 -variable flagr
label .twelveB.vsini -text "  vsini "
entry .twelveB.entry -textvariable vsini -width 6 -relief sunken -background white
label .twelveB.kms -text "km/s"
pack .twelveB.rotate .twelveB.0 .twelveB.vsini .twelveB.entry .twelveB.kms -side left
label .twelveC.smooth -text "Smooth: "
checkbutton .twelveC.0 -variable flags
label .twelveC.rlabel -text " Resolution "
entry .twelveC.entry1 -textvariable res -width 5 -relief sunken -background white
label .twelveC.rA -text "A "
label .twelveC.slabel -text " Spacing* "
entry .twelveC.entry2 -textvariable spc -width 5 -relief sunken -background white
label .twelveC.rA2 -text "A "
label .twelveC.shlabel -text " Shape* "
entry .twelveC.entry3 -textvariable shp -width 5 -relief sunken -background white
pack .twelveC.smooth .twelveC.0 .twelveC.rlabel .twelveC.entry1 .twelveC.rA \
.twelveC.slabel .twelveC.entry2 .twelveC.rA2 .twelveC.shlabel .twelveC.entry3 -side left
label .twelveD.star -text "*Output spacing should be integral multiple of computation spacing" -font {fixed 6}
pack .twelveD.star -side left
label .twelveE.star -text "*Shape=0 => pure Gaussian,  Shape=1 => pure Lorentzian  0 <= Shape <= 1" -font {fixed 6}
pack .twelveE.star -side left
radiobutton .test.0 -variable flagc -value 0 -text "Test" -font {times 14}
pack .test.0 -side left
radiobutton .vary.0 -variable flagc -value 1 -text "Vary" -font {times 14}
checkbutton .vary.1a -variable var1 -width 2
label .vary.1b -text "    "  -width 7
checkbutton .vary.2a -variable var2 -width 2
label .vary.2b -text "    "  -width 6
checkbutton .vary.3a -variable var3 -width 2
label .vary.3b -text "    "  -width 7
checkbutton .vary.4a -variable var4 -width 2
pack .vary.0 .vary.1a .vary.1b .vary.2a .vary.2b .vary.3a .vary.3b .vary.4a -side left
label .vary1.2a -text "Code " -width 8
entry .vary1.3a -textvariable codeA -width 7 -relief sunken -background white
label .vary1.2b -text "  " -width 4
entry .vary1.3b -textvariable codeB -width 7 -relief sunken -background white
label .vary1.2c -text "  " -width 4
entry .vary1.3c -textvariable codeC -width 7 -relief sunken -background white
label .vary1.2d -text "  " -width 4
entry .vary1.3d -textvariable codeD -width 7 -relief sunken -background white
pack .vary1.2a .vary1.3a .vary1.2b .vary1.3b .vary1.2c .vary1.3c .vary1.2d .vary1.3d -side left
label .vary2.2a -text "Begin  " -width 8
entry .vary2.3a -textvariable beginA -width 7 -relief sunken -background white
label .vary2.2b -text "  " -width 4
entry .vary2.3b -textvariable beginB -width 7 -relief sunken -background white
label .vary2.2c -text "  " -width 4
entry .vary2.3c -textvariable beginC -width 7 -relief sunken -background white
label .vary2.2d -text "  " -width 4
entry .vary2.3d -textvariable beginD -width 7 -relief sunken -background white
pack .vary2.2a .vary2.3a .vary2.2b .vary2.3b .vary2.2c .vary2.3c .vary2.2d .vary2.3d -side left
label .vary3.2a -text "Step " -width 8
entry .vary3.3a -textvariable stepA -width 7 -relief sunken -background white
label .vary3.2b -text "  " -width 4
entry .vary3.3b -textvariable stepB -width 7 -relief sunken -background white
label .vary3.2c -text "  " -width 4
entry .vary3.3c -textvariable stepC -width 7 -relief sunken -background white
label .vary3.2d -text "  " -width 4
entry .vary3.3d -textvariable stepD -width 7 -relief sunken -background white
pack .vary3.2a .vary3.3a .vary3.2b .vary3.3b .vary3.2c .vary3.3c .vary3.2d .vary3.3d -side left
radiobutton .best.0 -variable flagc -value 2 -text "Best" -font {times 14}
checkbutton .best.1a -variable bes1 -width 2
label .best.1b -text "    "  -width 7
checkbutton .best.2a -variable bes2 -width 2
label .best.2b -text "    "  -width 6
checkbutton .best.3a -variable bes3 -width 2
label .best.3b -text "    "  -width 7
checkbutton .best.4a -variable bes4 -width 2
pack .best.0 .best.1a .best.1b .best.2a .best.2b .best.3a .best.3b .best.4a -side left
label .best1.2a -text "Code " -width 8
entry .best1.3a -textvariable bcodeA -width 7 -relief sunken -background white
label .best1.2b -text "  " -width 4
entry .best1.3b -textvariable bcodeB -width 7 -relief sunken -background white
label .best1.2c -text "  " -width 4
entry .best1.3c -textvariable bcodeC -width 7 -relief sunken -background white
label .best1.2d -text "  " -width 4
entry .best1.3d -textvariable bcodeD -width 7 -relief sunken -background white
pack .best1.2a .best1.3a .best1.2b .best1.3b .best1.2c .best1.3c .best1.2d .best1.3d -side left
label .best2.2a -text "Best   " -width 8
entry .best2.3a -textvariable bestA -width 7 -relief sunken -background white
label .best2.2b -text "  " -width 4
entry .best2.3b -textvariable bestB -width 7 -relief sunken -background white
label .best2.2c -text "  " -width 4
entry .best2.3c -textvariable bestC -width 7 -relief sunken -background white
label .best2.2d -text "  " -width 4
entry .best2.3d -textvariable bestD -width 7 -relief sunken -background white
pack .best2.2a .best2.3a .best2.2b .best2.3b .best2.2c .best2.3c .best2.2d .best2.3d -side left
button .control.run -text "Run" -command Run
pack .control.run -side left -ipady 10 -padx 60
button .control.quit -text "Quit" -command Quit
pack .control.quit -side left -ipady 10 -ipadx 10 -padx 40
pack .one .two .twoB .twoC .three .four .five .six .seven .eight .eightB .nine .nineB .nineC .ten  \
.eleven .twelveA .twelveB .twelveC .twelveD .twelveE .test .vary .vary1 .vary2 .vary3 .best .best1 .best2 \
.control -side top -fill x
set flagc 0
set spectrum "Needs Input       "
set model "Not Selected         "
set atom  "Not Selected         "
set isotope "Not Selected         "
set output  "Not Selected         "
set lines   "Not Selected         "
set start 6350.0
set waveS $start
set end 6450.0
set waveE $end
set space 0.01
set pids 100
set pwd [pwd]
set vsini 0
set spc 0.1
set res 0.4
set shp 0.0
set vt 2.0
set mt 1.0
set k -1
set flagm 0
set flagm 0
set flagi 0
set flag9 0
set flagr 0
set flags 0
set flagp 0
set flagmt 0
set status "Expecting Input"
set modelflag 0
set atomflag 0
set isotopeflag 0
set listflag 0
set outflag 0
set n 10

proc Pstat {pids} {
  global k flagp wavep
  set n 2
  while {1} {
   after 500
   catch {set n [exec ps hp $pids > tmp.wc]}
   set m [exec wc -l tmp.wc]
   scan $m {%d %s} k tmpstr
   if {$k == 0} {
    return
   }
   if {$flagp == 1} {
    set line [exec tail -n 2 tmp.out | head -n 1]
    scan $line "%f %f" wavep inten
   }
   update
  }
}

proc Getspectrum {} {
   global spectrum spectrumflag pwd
   set types {
       {{All Files} {*}}
}
   set spectrum [tk_getOpenFile -filetypes $types -title "Select Spectrum" -initialdir $pwd]
   set .twoB.spectrum.text $spectrum
   if {$spectrum != ""} {
     set spectrumflag 1
   } else {
     set spectrumflag 0
   }
}

proc Getmodel {} {
   global model modelflag pwd
   set types {
       {{mod files} {.mod} }
       {{Atlas12 models} {.m12}}
       {{Atlas9 models} {.width9}}
       {{dat files} {.dat}}
       {{All Files} {*}}
}
   set model [tk_getOpenFile -filetypes $types -title "Select Model" -initialdir $pwd]
   set .four.model.text $model
   if {$model != ""} {
     set modelflag 1
   } else {
     set modelflag 0
   }
}

proc Getatom {} {
   global atom atomflag pwd
   set types {
       {{dat files} {.dat}}
       {{All Files} {*}}
}
   set atom [tk_getOpenFile -filetypes $types -title "Select Atomic Data File" -initialdir $pwd]
   set .five.atom.text $atom
   if {$atom != ""} {
     set atomflag 1
   } else {
     set atomflag 0
   }
}

proc Getisotope {} {
   global isotope isotopeflag pwd
   set types {
       {{dat files} {.iso}}
       {{All Files} {*}}
}
   set isotope [tk_getOpenFile -filetypes $types -title "Select Isotope File" -initialdir $pwd]
   set .six.isotope.text $isotope
   if {$isotope != ""} {
     set isotopeflag 1
   } else {
     set isotopeflag 0
   }
}

proc Getline {} {
   global lines listflag
   set types {
       {{dat files} {.lst}}
       {{All Files} {*}}
}
   set lines [tk_getOpenFile -filetypes $types -title "Select Line List"]
   set .seven.lines.text $lines
   if {$lines != ""} {
     set listflag 1
   } else {
     set listflag 0
   }
}

proc Getoutput {} {
   global output outflag pwd
   set types {
       {{All Files} {*}}
   }
   set output [tk_getSaveFile -filetypes $types -title "Output File" -initialdir $pwd]
   set .eight.output.text $output
   if {$output != ""} {
     set outflag 1
   } else {
     set outflag 0
   }
}

proc Run {} {
    global spectrum start end k vt n pids pwd flagm flagc
    global model atom isotope lines output space var1 var2 var3 var4
    global bes1 bes2 bes3 bes4
    global bcodeA bcodeB bcodeC bcodeD bestA bestB bestC bestD
    global modelflag atomflag isotopeflag listflag outflag
    global pwd flags flagr flag9 flagi flagmt mt vsini res spc wavep shp
    global codeA beginA stepA codeB beginB stepB codeC beginC stepC
    global codeD beginD stepD atm outpt

    if {$modelflag == 0 || $atomflag == 0 || $listflag == 0 || $outflag == 0} {
     tk_messageBox -type ok -message "Input not complete!" -icon question
     return
   }
   if {$isotopeflag == 0 && $flagi == 1} {
     tk_messageBox -type ok -message "Select Isotope file!" -icon question
     return
   }
   if {$k > 0} {
     tk_messageBox -type ok -message "Spectrum already running!" -icon question
     return
   }

   if {$flagc == 0} {
    set atm $atom
    set outpt $output
    
    Execute
    Pstat $pids
    Pstat $n
   
    set waveS $start
    set waveE $end

    set xmkrsp [open xmk25.rsp w]
    set fstr $spectrum
    append fstr "+"
    append fstr $output
    puts $xmkrsp $fstr
    set fstr "0"
    puts $xmkrsp $fstr
    close $xmkrsp
    catch {exec xmk25 < xmk25.rsp}
   } elseif {$flagc == 1} {
       set n [exec cp $atom atom1.dat]
       set n [exec cp $atom atom2.dat]
       set n [exec cp $atom atom3.dat]
       set n [exec cp $atom atom4.dat]
       if {$var1 == 1} { 
           set bA $beginA
	   set n [exec newatom atom1.dat atom1.dat $codeA $bA]
           set bA [expr $bA + $stepA]
           set n [exec newatom atom2.dat atom2.dat $codeA $bA]
           set bA [expr $bA + $stepA]
           set n [exec newatom atom3.dat atom3.dat $codeA $bA]
           set bA [expr $bA + $stepA]
           set n [exec newatom atom4.dat atom4.dat $codeA $bA]
       } 
       if {$var2 == 1} {
           set bB $beginB
	   set n [exec newatom atom1.dat atom1.dat $codeB $bB]
           set bB [expr $bB + $stepB]
           set n [exec newatom atom2.dat atom2.dat $codeB $bB]
           set bB [expr $bB + $stepB]
           set n [exec newatom atom3.dat atom3.dat $codeB $bB]
           set bB [expr $bB + $stepB]
           set n [exec newatom atom4.dat atom4.dat $codeB $bB]
       }  
       if {$var3 == 1} {
           set bC $beginC
	   set n [exec newatom atom1.dat atom1.dat $codeC $bC]
           set bC [expr $bC + $stepC]
           set n [exec newatom atom2.dat atom2.dat $codeC $bC]
           set bC [expr $bC + $stepC]
           set n [exec newatom atom3.dat atom3.dat $codeC $bC]
           set bC [expr $bC + $stepC]
           set n [exec newatom atom4.dat atom4.dat $codeC $bC]
       } 
       if {$var4 == 1} {
           set bD $beginD
	   set n [exec newatom atom1.dat atom1.dat $codeD $bD]
           set bD [expr $bD + $stepD]
           set n [exec newatom atom2.dat atom2.dat $codeD $bD]
           set bD [expr $bD + $stepD]
           set n [exec newatom atom3.dat atom3.dat $codeD $bD]
           set bD [expr $bD + $stepD]
           set n [exec newatom atom4.dat atom4.dat $codeD $bD]
       } 
    set atm "atom1.dat"
    set outpt "out1.spc"
    set output1 "out1.spc"    

    Execute
    Pstat $pids
    Pstat $n

    set atm "atom2.dat"
    set outpt "out2.spc"
    set output2 "out2.spc"

    Execute
    Pstat $pids
    Pstat $n

    set atm "atom3.dat"
    set outpt "out3.spc"
    set output3 "out3.spc"

    Execute
    Pstat $pids
    Pstat $n

    set atm "atom4.dat"
    set outpt "out4.spc"
    set output4 "out4.spc"

    Execute
    Pstat $pids
    Pstat $n

    set waveS $start
    set waveE $end

    set xmkrsp [open xmk25.rsp w]
    set fstr $spectrum
    append fstr "+out1.spc+out2.spc+out3.spc+out4.spc"
    puts $xmkrsp $fstr
    set fstr "0"
    puts $xmkrsp $fstr
    close $xmkrsp
    catch {exec xmk25 < xmk25.rsp}
   } elseif {$flagc == 2} {
       set n [exec cp $atom atom1.dat]
       if {$bes1 == 1} { 
          set bA $bestA
	  set n [exec newatom atom1.dat atom1.dat $bcodeA $bA]
       }
       if {$bes2 == 1} {
          set bB $bestB
	  set n [exec newatom atom1.dat atom1.dat $bcodeB $bB]
       }
       if {$bes3 == 1} {
          set bC $bestC
          set n [exec newatom atom1.dat atom1.dat $bcodeC $bC]
       }
       if {$bes4 == 1} {
          set bD $bestD
	  set n [exec newatom atom1.dat atom1.dat $bcodeD $bD]
       }
    set atm "atom1.dat"
    set outpt $output    

    Execute
    Pstat $pids
    Pstat $n

    set waveS $start
    set waveE $end

    set xmkrsp [open xmk25.rsp w]
    set fstr $spectrum
    append fstr "+"
    append fstr $output
    puts $xmkrsp $fstr
    set fstr "0"
    puts $xmkrsp $fstr
    close $xmkrsp
    catch {exec xmk25 < xmk25.rsp}
   }
 
       
}


proc Execute {} {
    global spectrum start end k vt n pids pwd flagm flagc
    global model atm isotope lines outpt space var1 var2 var3 var4
    global modelflag atomflag isotopeflag listflag outflag
    global pwd flags flagr flag9 flagi flagmt mt vsini res spc wavep shp
    global codeA beginA stepA codeB beginB stepB codeC beginC stepC
    global codeD beginD stepD

    if {$modelflag == 0 || $atomflag == 0 || $listflag == 0 || $outflag == 0} {
     tk_messageBox -type ok -message "Input not complete!" -icon question
     return
   }
   if {$isotopeflag == 0 && $flagi == 1} {
     tk_messageBox -type ok -message "Select Isotope file!" -icon question
     return
   }
   if {$k > 0} {
     tk_messageBox -type ok -message "Spectrum already running!" -icon question
     return
   }

    cd $pwd
    set status "Executing..."
    set wavep $start
    set rspId [open tmp.rsp w]
    puts $rspId $model
    puts $rspId $lines
    puts $rspId $atm
    if {$flagi == 1} {
       puts $rspId $isotope
    }
    puts $rspId "tmp.out"
    puts $rspId $vt
    if {$flagm == 2} {
       puts $rspId 1.0
    }
    puts $rspId $start,$end
    puts $rspId $space
    close $rspId

    if {$flagi == 0 && $flag9 == 0} {
      set pids [exec spectrum an < tmp.rsp > out.out &]
    } elseif {$flagi == 1 && $flag9 == 0} {
      set pids [exec spectrum ani < tmp.rsp > out.out &]
    } elseif {$flagi == 0 && $flag9 == 1} {
      set pids [exec spectrum ant < tmp.rsp > out.out &]
    } else {
      set pids [exec spectrum aint < tmp.rsp > out.out &]
    }   
     Pstat $pids
     if {$flagmt == 0} {
       if {$flagr == 1 && $flags == 0} {
          set n [exec avsini tmp.out $outpt $vsini 0.6 $space]
          file delete tmp.out
       } elseif {$flagr == 1 && $flags == 1} {
          set n [exec avsini tmp.out tmpv.out $vsini 0.6 $space]
          set n [exec customsm tmpv.out $outpt $space $res $spc $shp]
          file delete tmp.out
          file delete tmpv.out
       } elseif {$flagr == 0 && $flags == 1} {
          set n [exec customsm tmp.out $outpt $space $res $spc $shp]
          file delete tmp.out
       } elseif {$flagr == 0 && $flags == 0 } {
	   set n [exec mv tmp.out $outpt]
       }
     } elseif {$flagmt == 1} {
	 set n [exec macturb tmp.out tmp1.out $space $mt]
       if {$flagr == 1 && $flags == 0} {
          set n [exec avsini tmp1.out $outpt $vsini 0.6 $space]
          file delete tmp.out
       } elseif {$flagr == 1 && $flags == 1} {
          set n [exec avsini tmp1.out tmpv.out $vsini 0.6 $space]
          set n [exec customsm tmpv.out $outpt $space $res $spc $shp]
          file delete tmp.out
          file delete tmpv.out
       } elseif {$flagr == 0 && $flags == 1} {
          set n [exec customsm tmp1.out $outpt $space $res $spc $shp]
          file delete tmp.out
       } elseif {$flagr == 0 && $flags == 0 } {
	   set n [exec mv tmp.out $outpt]
       }
       file delete tmp1.out
    }
}


proc Quit {} {
   global k pids
   if {$k > 0} {
     set choice [tk_messageBox -type yesno \
         -message "Spectrum is running! Quit?" -icon question]
     switch -- $choice {
       yes {
         exec kill $pids
         exit
       }
       no return
     }
   }
   exit
}
