#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
char *ggets(char *s);

int main(int argc, char *argv[])
{
  FILE *in;
  FILE *out;
  int code[110],mc[110],CODE,ni;
  double Abund[110],Amass[110],I1[110],I2[110],I3[110],I4[110];
  char header[80],inatom[300],outatom[300];
  double DMH;
  int i,j,k;

  if(argc != 5) {
    printf("\nEnter name of original atom file > ");
    ggets(inatom);
    printf("\nEnter name of modified atom file > ");
    ggets(outatom);
    printf("\nEnter code of element to be modified > ");
    ni = scanf("%d",&CODE);
    printf("\nEnter change in abundance > ");
    ni = scanf("%lf",&DMH);
  } else {
    strcpy(inatom,argv[1]);
    strcpy(outatom,argv[2]);
    CODE = atoi(argv[3]);
    DMH = atof(argv[4]);
  }

  if((in = fopen(inatom,"r")) == NULL) {
    printf("\nError opening input file\n");
    exit(1);
  }

  if(fgets(header,80,in) == NULL) {
    printf("Error in file header\n");
    exit(1);
  }
  k = 0;
  while(fscanf(in,"%d %lf %lf %lf %lf %lf %lf %d",&code[k],&Abund[k],
	       &Amass[k],&I1[k],&I2[k],&I3[k],&I4[k],&mc[k]) != EOF) k++;

  fclose(in);

  for(i=0;i<k;i++) {
    if(CODE == code[i]) {
      Abund[i] += DMH;
      break;
    }
  }

  out = fopen(outatom,"w");

  fprintf(out,"%s",header);
  for(i=0;i<k;i++) {
    fprintf(out,"%3d %8.4f %8.4f %6.3f %8.5f %7.3f %7.3f %d\n",code[i],
	    Abund[i],Amass[i],I1[i],I2[i],I3[i],I4[i],mc[i]);
  }
  fclose(out);
}


char *ggets(char *s)
{
  size_t n;
  char tmp[300];

  if(fgets(tmp,300,stdin) == NULL) {
    printf("Access error in ggets\n");
    exit(1);
  }
  n = strlen(tmp);
  strncpy(s,tmp,n-1);
  s[n-1] = '\0';
  return(s);
}
