#include <stdlib.h>
void nrerror();

float *vector(nl,nh)
int nl,nh;
{
    float *v;

    v = (float *)malloc((unsigned) (nh-nl+1)*sizeof(float));
    if(!v) nrerror("allocation failure in vector()");
    return v-nl;
}

void free_vector(v,nl,nh)
float *v;
int nl,nh;
{
    free((char*) (v+nl));
}


double *dvector(nl,nh)
int nl,nh;
{
    double *v;

    v=(double *)malloc((unsigned) (nh-nl+1)*sizeof(double));
    if(!v) nrerror("allocation failure in dvector()");
    return v-nl;
}

void free_dvector(v,nl,nh)
double *v;
int nl,nh;
{
    free((char*) (v+nl));
}

int *ivector(nl,nh)
int nl,nh;
{
    int *v;

    v = (int *)malloc((unsigned) (nh-nl+1)*sizeof(int));
    if(!v) nrerror("allocation failure in ivector()");
    return v-nl;
}

void free_ivector(v,nl,nh)
int *v,nl,nh;
{
    free((char*) (v+nl));
}

double *cvector(nl,nh)
int nl,nh;
{
    double *v;

    v = (double *)calloc((nh-nl+1),sizeof(double));
    if(!v) nrerror("allocation failure in cvector()");
    return v-nl;
}

unsigned long *lvector(long nl,long nh)
{
    unsigned long *v;

    v = (unsigned long *)malloc((unsigned) (nh-nl+1)*sizeof(long));
    if(!v) nrerror("allocation failure in ivector()");
    return v-nl;
}

void free_lvector(unsigned long *v,long nl,long nh)
{
    free((char*) (v+nl));
}
