#define XWIN_UTIL

#include "xwins.h"
#include "app_glob.c"

void xwin_init(void)
{
  xwin_context = XUniqueContext();
}

void AddNewEvent(Window xid, long event_mask)
{
  XWindowAttributes  xwa;
  XSetWindowAttributes xswa;

  if(XGetWindowAttributes(theDisplay,xid,&xwa) != 0) {
    xswa.event_mask = xwa.your_event_mask | event_mask;
    XChangeWindowAttributes(theDisplay,xid,CWEventMask,&xswa);
  }
}

void IgnoreEvent(Window xid, long event_mask)
{
  XWindowAttributes xwa;
  XSetWindowAttributes xswa;

  if(XGetWindowAttributes(theDisplay,xid,&xwa) != 0) {
    xswa.event_mask = xwa.your_event_mask & (~event_mask);
    XChangeWindowAttributes(theDisplay,xid,CWEventMask,&xswa);
  }
}
