#include <stdio.h>
#include <math.h>
#include <stdlib.h>

double eqwdth(double *wave,double *flux)
{
  extern int nf;
  extern double cont;
  extern unsigned long nd[20];
  extern double space;
  double sum,y1,y2;
  int i;

  sum = 0.0;
  for(i=nd[1];i<nd[2]-1;i++) {
    y1 = 1.0 - flux[i];
    y2 = 1.0 - flux[i+1];
    if(y1 < 0.001) continue;
    sum += 0.5*(y1 + y2)*space;
  }
  return(1000.0*sum/cont);
}

double eqwdth2(double *wave,double *flux)
{
  extern int nf;
  extern double cont;
  extern unsigned long nd[20];
  extern double space;
  double sum,y1,y2;
  int i;

  sum = 0.0;
  for(i=nd[2];i<nd[3]-1;i++) {
    y1 = 1.0 - flux[i];
    y2 = 1.0 - flux[i+1];
    if(y1 < 0.001) continue;
    sum += 0.5*(y1 + y2)*space;
  }
  return(1000.0*sum/cont);
}
