#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "xwins.h"
#include "app_glob.c"
void updash();
void downdash();
void rightdash();
void leftdash();
void tvdash();


void xaxis(xlow,xhigh,xtics,ylow,yhigh,ytics,x1,x2,y1,y2)
double xlow,xhigh,ylow,yhigh;
int xtics,ytics,x1,x2,y1,y2;
{
  int Xpos,Ypos,i,xpos[7],ypos[7],xp,yp;
  double dxt,xt,dyt,yt;
  double Dx,Dy,XP,YP;
  double X1,X2;
  int nx,dx,dy,ny,xps,dxps,yps,dyps;
  int f1=0,f2=0;
  char sxt[20],syt[20];
  extern char title[100];

  X1 = (double)x1;
  X2 = (double)x2;

  xpos[0] = x1;
  if(xtics%6 == 0) {
     Dx = (xhigh - xlow)/6.0;
     xpos[0] = x1;
     XP = xlow;
     for(i=1;i<7;i++) {
       XP += Dx;
       xpos[i] = X1 + (X2 - X1)*(XP-xlow)/(xhigh-xlow);
     }
     nx = 6;
  }
  else if(xtics%5 == 0 && f1 != 1) {
     Dx = (xhigh - xlow)/5.0;
     xpos[0] = x1;
     XP = xlow;
     for(i=1;i<6;i++) {
       XP += Dx;
       xpos[i] = X1 + (X2 - X1)*(XP-xlow)/(xhigh-xlow);
     } 
     nx = 5;
  }
  else if(xtics%4 == 0 && f1 != 1) {
     Dx = (xhigh - xlow)/4.0;
     xpos[0] = x1;
     XP = xlow;
     for(i=1;i<5;i++) {
       XP += Dx;
       xpos[i] = X1 + (X2 - X1)*(XP-xlow)/(xhigh-xlow);
     } 
     nx = 4;
  }
  else if(xtics%3 == 0 && f1 != 1) {
     Dx = (xhigh - xlow)/3.0;
     xpos[0] = x1;
     XP = xlow;
     for(i=1;i<4;i++) {
       XP += Dx;
       xpos[i] = X1 + (X2 - X1)*(XP-xlow)/(xhigh-xlow);
     } 
     nx = 3;
  }
  else if(xtics%2 == 0 && f1 != 1) {
     Dx = (xhigh - xlow)/2.0;
     xpos[0] = x1;
     XP = xlow;
     for(i=1;i<5;i++) {
       XP += Dx;
       xpos[i] = X1 + (X2 - X1)*(XP-xlow)/(xhigh-xlow);
     } 
     nx = 2;
  } else {
     xpos[0] = x1;
     xpos[1] = x2;
     nx = 1;
  }

   ypos[0] = y1;
  if(ytics%6 == 0 && f1 != 1) {
     dy = (y2 - y1)/6;
     for(i=1;i<7;i++) ypos[i] = ypos[i-1] + dy;
     ny = 6;
  }
  else if(ytics%5 == 0 && f1 != 1) {
     dy = (y2 - y1)/5;
     for(i=1;i<6;i++) ypos[i] = ypos[i-1] + dy;
     ny = 5;
  }
  else if(ytics%4 == 0 && f1 != 1) {
     dy = (y2 - y1)/4;
     for(i=1;i<5;i++) ypos[i] = ypos[i-1] + dy;
     ny = 4;
  }
  else if(ytics%3 == 0 && f1 != 1) {
     dy = (y2 - y1)/3;
     for(i=1;i<4;i++) ypos[i] = ypos[i-1] + dy;
     ny = 3;
  }
  else if(ytics%2 == 0 && f1 != 1) {
     dy = (y2 - y1)/2;
     for(i=1;i<5;i++) ypos[i] = ypos[i-1] + dy;
     ny = 2;
  } else {
     ypos[0] = y1;
     ypos[1] = y2;
     ny = 1;
  }

  XDrawLine(theDisplay,theMain,theGC,x1,y1,x2,y1);
  XDrawLine(theDisplay,theMain,theGC,x1,y1,x1,y2);
  XDrawLine(theDisplay,theMain,theGC,x2,y1,x2,y2);
  XDrawLine(theDisplay,theMain,theGC,x1,y2,x2,y2);
  Xpos = x1 + (x2 - x1)/2 - 5*strlen("Wavelength")/2;
  XDrawString(theDisplay,theMain,theGC,Xpos,y1+35,"Wavelength",strlen("Wavelength"));
  Xpos = x1 + (x2 - x1)/2 - 5*strlen(title)/2;
  XDrawString(theDisplay,theMain,theGC,Xpos,y2-10,title,strlen(title));
  Xpos = x1;
  Ypos = y2;
  Dx = (xhigh - xlow)/(double)xtics;
  XP = xlow;
  dxps = (x2-x1)/xtics;
  dyps = (y1 - y2)/ytics;
  for(i=0;i<=xtics;i++) {
    updash(Xpos,y1);
    downdash(Xpos,y2);
    XP += Dx;
    Xpos = x1 + (x2 - x1)*(XP-xlow)/(xhigh-xlow);
  }
  for(i=0;i<=ytics;i++) {
    rightdash(x1,Ypos);
    leftdash(x2,Ypos);
    Ypos += dyps;
  }
  dxt = (xhigh - xlow)/nx;
  xt = xlow;
  for(i=0;i<=nx;i++) {
    sprintf(sxt,"%6.2f",xt);
    xp = xpos[i] - 5*strlen(sxt);
    XDrawString(theDisplay,theMain,theGC,xp,y1+18,sxt,strlen(sxt));
    xt += dxt;
  }

  dyt = (yhigh - ylow)/ny;
  yt = ylow;
  for(i=0;i<=ny;i++) {
    sprintf(syt,"%6.2g",yt);
    yp = ypos[i];
    xp = x1 - 5*strlen(syt) - 10;
    XDrawString(theDisplay,theMain,theGC,xp,yp,syt,strlen(syt));
    yt += dyt;
  }
}


void updash(x,y)
int x,y;
{
 int y2;
 y2 = y - 5;
 XDrawLine(theDisplay,theMain,theGC,x,y,x,y2);
}

void downdash(x,y)
int x,y;
{
 int y2;
 y2 = y + 5;
 XDrawLine(theDisplay,theMain,theGC,x,y,x,y2);
}

void rightdash(x,y)
int x,y;
{
 int x2;
 x2 = x+5;
 XDrawLine(theDisplay,theMain,theGC,x,y,x2,y);
}

void leftdash(x,y)
int x,y;
{
 int x2;
 x2 = x-5;
 XDrawLine(theDisplay,theMain,theGC,x,y,x2,y);
}

void tvdash(x,y)
int x,y;
{
 int y2;
 y2 = y+5;
 XDrawLine(theDisplay,theMain,theGC,x,y,x,y2);
}
